use crate::types::{TaggedType, TypeTag};

pub mod recursive;
#[cfg(test)]
mod test;
pub mod unification;

#[derive(Debug)]
pub enum InferError {
    NotAFunction,
    MismatchedType,
    NotInContext,
    ExpectedConreteType,
    DoesNotFitTag(TypeTag, TaggedType),
    ConfilictingTags,
    UnusableConstraint,
}
