mod exec;
mod inference;
mod multi_map;
mod parse;
mod types;
mod vec_map;

pub use exec::{Builtin, DeBrujinAst, builtin};
pub use inference::recursive::infer_type as infer_type_rec;
pub use inference::unification::infer_type as infer_type_uni;
pub use parse::{Ast, parse_ast_str, parse_type_str};
